Index: LMDZ.3.3/branches/rel-1-0-patch/libf/phylmd/physiq.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/phylmd/physiq.F	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/phylmd/physiq.F	(revision 253)
@@ -1507,35 +1718,102 @@
 c    s             d_t_con, d_q_con, 
 c    s             rain_con, snow_con, ibas_con, itop_con)
+cKE43
+      ELSE IF (iflag_con.EQ.4) THEN
+c nb of tracers for the KE convection:
+          if (nqmax .GE. 4) then
+              ntra = nbtr
+          else
+              ntra = 1 
+          endif
+cke43 (arguments inutiles enleves => des SAVE dans conema43?)
+c$$$          CALL conema43(dtime,paprs,pplay,t_seri,q_seri,
+c$$$     $        u_seri,v_seri,tr_seri,nbtr,
+c$$$     .        ema_workcbmf,
+c$$$     .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
+c$$$     .        wdn, tdn, qdn,
+c$$$     .        rain_con, snow_con, ibas_con, itop_con,
+c$$$     .        upwd,dnwd,dnwd0,bas,top,Ma,cape,tvp,rflag,
+c$$$     .        pbase
+c$$$     .        ,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,
+c$$$     .        pori_con,plcl_con,dtma_con,dtlcl_con)
+          CALL conema (dtime,paprs,pplay,t_seri,q_seri,
+     $        u_seri,v_seri,tr_seri,nbtr,
+     .        ema_work1,ema_work2,
+     .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
+c$$$     .        wdn, tdn, qdn,
+     .        rain_con, snow_con, ibas_con, itop_con,
+     .        upwd,dnwd,dnwd0,bas,top,Ma,cape,tvp,rflag,
+     .        pbase
+     .        ,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr)
+c$$$     .        pori_con,plcl_con,dtma_con,dtlcl_con)
+          DO i = 1, klon
+            ema_pcb(i)  = pbase(i)
+          ENDDO
+          DO i = 1, klon
+            ema_pct(i)  = paprs(i,itop_con(i))
+          ENDDO
+          DO i = 1, klon
+            ema_cbmf(i) = ema_workcbmf(i)
+          ENDDO      
       ELSE
-      PRINT*, "iflag_con non-prevu", iflag_con
-      CALL abort
+          PRINT*, "iflag_con non-prevu", iflag_con
+          CALL abort
       ENDIF
       CALL homogene(paprs, q_seri, d_q_con, u_seri,v_seri,
      .              d_u_con, d_v_con)
       DO k = 1, klev
-      DO i = 1, klon
-         t_seri(i,k) = t_seri(i,k) + d_t_con(i,k)
-         q_seri(i,k) = q_seri(i,k) + d_q_con(i,k)
-         u_seri(i,k) = u_seri(i,k) + d_u_con(i,k)
-         v_seri(i,k) = v_seri(i,k) + d_v_con(i,k)
-      ENDDO
+        DO i = 1, klon
+          t_seri(i,k) = t_seri(i,k) + d_t_con(i,k)
+          q_seri(i,k) = q_seri(i,k) + d_q_con(i,k)
+          u_seri(i,k) = u_seri(i,k) + d_u_con(i,k)
+          v_seri(i,k) = v_seri(i,k) + d_v_con(i,k)
+        ENDDO
       ENDDO
       IF (check) THEN
-         CALL qcheck(klon,klev,paprs,q_seri,ql_seri,"aprescon=")
-         zx_t = 0.0
-         DO i = 1, klon
-            zx_t = zx_t + rain_con(i)+snow_con(i)
-         ENDDO
-         zx_t = zx_t/FLOAT(klon)*dtime
-         PRINT*, "Precip=", zx_t
-      ENDIF
+          za = qcheck(klon,klev,paprs,q_seri,ql_seri,paire)
+          PRINT*, "aprescon=", za
+          zx_t = 0.0
+          za = 0.0
+          DO i = 1, klon
+            za = za + paire(i)/FLOAT(klon)
+            zx_t = zx_t + (rain_con(i)+snow_con(i))*paire(i)/FLOAT(klon)
+          ENDDO
+          zx_t = zx_t/za*dtime
+          PRINT*, "Precip=", zx_t
+      ENDIF
+      IF (zx_ajustq) THEN
+          DO i = 1, klon
+            z_apres(i) = 0.0
+          ENDDO
+          DO k = 1, klev
+            DO i = 1, klon
+              z_apres(i) = z_apres(i) + (q_seri(i,k)+ql_seri(i,k))
+     .            *(paprs(i,k)-paprs(i,k+1))/RG
+            ENDDO
+          ENDDO
+          DO i = 1, klon
+            z_factor(i) = (z_avant(i)-(rain_con(i)+snow_con(i))*dtime)
+     .          /z_apres(i)
+          ENDDO
+          DO k = 1, klev
+            DO i = 1, klon
+              IF (z_factor(i).GT.(1.0+1.0E-08) .OR.
+     .            z_factor(i).LT.(1.0-1.0E-08)) THEN
+                  q_seri(i,k) = q_seri(i,k) * z_factor(i)
+              ENDIF
+            ENDDO
+          ENDDO
+      ENDIF
+      zx_ajustq=.FALSE.
 c
       IF (nqmax.GT.2) THEN !--melange convectif de traceurs
 c
-      IF (iflag_con.NE.2) THEN
-         PRINT*, "Pour l instant, seul conflx fonctionne avec traceurs"
-         PRINT*,' Mettre iflag_con = 2  dans  run.def et repasser  !'
-         CALL abort
-      ENDIF
+          IF (iflag_con .NE. 2 .AND.  iflag_con .NE. 4 ) THEN 
+              PRINT*, 'Pour l instant, seul conflx fonctionne ',
+     $            'avec traceurs', iflag_con
+              PRINT*,' Mettre iflag_con', 
+     $            ' = 2  ou 4 dans run.def et repasser'
+              CALL abort
+              ENDIF 
 c
       ENDIF !--nqmax.GT.2
@@ -1543,5 +1821,16 @@
 c Appeler l'ajustement sec
 c
-C appel supprime pour le moment
+      CALL ajsec(paprs, pplay, t_seri, q_seri, d_t_ajs, d_q_ajs)
+      DO k = 1, klev
+      DO i = 1, klon
+         t_seri(i,k) = t_seri(i,k) + d_t_ajs(i,k)
+         q_seri(i,k) = q_seri(i,k) + d_q_ajs(i,k)
+      ENDDO
+      ENDDO
+
+c   RATQS
+      call calcratqs (
+     I            paprs,pplay,q_seri,d_t_con,d_t_ajs
+     O           ,ratqs,zpt_conv)
 c
 c Appeler le processus de condensation a grande echelle
@@ -1549,9 +1838,10 @@
 c
       CALL fisrtilp_tr(dtime,paprs,pplay,
-     .           t_seri, q_seri,
+     .           t_seri, q_seri,ratqs,
      .           d_t_lsc, d_q_lsc, d_ql_lsc, rneb, cldliq,
      .           rain_lsc, snow_lsc,
      .           pfrac_impa, pfrac_nucl, pfrac_1nucl,
-     .           frac_impa, frac_nucl )
+     .           frac_impa, frac_nucl,
+     .           prfl, psfl)
       DO k = 1, klev
       DO i = 1, klon
@@ -1564,10 +1854,13 @@
       ENDDO
       IF (check) THEN
-         CALL qcheck(klon,klev,paprs,q_seri,ql_seri,"apresilp=")
+         za = qcheck(klon,klev,paprs,q_seri,ql_seri,paire)
+         PRINT*, "apresilp=", za
          zx_t = 0.0
+         za = 0.0
          DO i = 1, klon
-            zx_t = zx_t + rain_lsc(i)+snow_lsc(i)
-         ENDDO
-         zx_t = zx_t/FLOAT(klon)*dtime
+            za = za + paire(i)/FLOAT(klon)
+            zx_t = zx_t + (rain_lsc(i)+snow_lsc(i))*paire(i)/FLOAT(klon)
+        ENDDO
+         zx_t = zx_t/za*dtime
          PRINT*, "Precip=", zx_t
       ENDIF
@@ -1576,7 +1869,21 @@
 c
       IF (iflag_con.EQ.2) THEN ! seulement pour Tiedtke
-      CALL diagcld(paprs,pplay,t_seri,q_seri,
+      CALL diagcld1(paprs,pplay,
      .             rain_con,snow_con,ibas_con,itop_con,
      .             diafra,dialiq)
+      DO k = 1, klev
+      DO i = 1, klon
+      IF (diafra(i,k).GT.cldfra(i,k)) THEN
+         cldliq(i,k) = dialiq(i,k)
+         cldfra(i,k) = diafra(i,k)
+      ENDIF
+      ENDDO
+      ENDDO
+      ENDIF
+c
+c Nuages stratus artificiels:
+c
+      IF (ok_stratus) THEN
+      CALL diagcld2(paprs,pplay,t_seri,q_seri, diafra,dialiq)
       DO k = 1, klev
       DO i = 1, klon
@@ -1792,9 +2099,25 @@
 c   Calcul  des tendances traceurs
 c====================================================================
+C Pascale : il faut quand meme apeller phytrac car il gere les sorties
+cKE43       des traceurs => il faut donc mettre des flags a .false.
+      IF (iflag_con.EQ.4) THEN
+c           on ajoute les tendances calculees par KE43
+        DO iq=1, nqmax-2 ! Sandrine a -3 ???
+        DO k = 1, nlev
+        DO i = 1, klon
+          tr_seri(i,k,iq) = tr_seri(i,k,iq) + d_tr(i,k,iq)
+        ENDDO
+        ENDDO
+        WRITE(iqn,'(i2.2)') iq
+        CALL minmaxqfi(tr_seri(1,1,iq),0.,1.e33,'couche lim iq='//iqn)
+        ENDDO
+CMAF modif pour garder info du nombre de traceurs auxquels
+C la physique s'applique
+      ELSE
 CMAF modif pour garder info du nombre de traceurs auxquels
 C la physique s'applique
 C
       call phytrac (rnpb,
-     I                   debut,
+     I                   debut,lafin,
      I                   nqmax-2,
      I                   nlon,nlev,dtime,
@@ -1805,11 +2128,15 @@
      I                   rlon,presnivs,paire,pphis,
      O                   tr_seri)
+      ENDIF 
 
       IF (offline) THEN
-      call phystoke (
-     I                   nlon,nlev,pdtphys,
-     I                   pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+
+	 call phystokenc (
+     I                   nlon,nlev,pdtphys,rlon,rlat,
+     I                   t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
      I                   ycoefh,yu1,yv1,ftsol,pctsrf,
-     I                   frac_impa, frac_nucl)
+     I                   frac_impa, frac_nucl,
+     I                   pphis,paire,dtime,itap)
+
 
       ENDIF
